OpenJPEG: opj_cp Struct Reference

OpenJPEG 2.5.4

Data Fields
opj_cp Struct Reference

Coding parameters. More...

`#include <j2k.h>`

## Data Fields
OPJ_UINT16 | rsiz
| Size of the image in bits.
OPJ_UINT32 | tx0
| XTOsiz.
OPJ_UINT32 | ty0
| YTOsiz.
OPJ_UINT32 | tdx
| XTsiz.
OPJ_UINT32 | tdy
| YTsiz.
OPJ_CHAR * | comment
| comment
OPJ_UINT32 | tw
| number of tiles in width
OPJ_UINT32 | th
| number of tiles in height
OPJ_UINT32 | ppm_markers_count
| number of ppm markers (reserved size)
opj_ppx * | ppm_markers
| ppm markers data (table indexed by Zppm)
OPJ_BYTE * | ppm_data
| packet header store there for future use in t2_decode_packet
OPJ_UINT32 | ppm_len
| size of the ppm_data
OPJ_UINT32 | ppm_data_read
| size of the ppm_data
OPJ_BYTE * | ppm_data_current
OPJ_BYTE * | ppm_buffer
| packet header storage original buffer
OPJ_BYTE * | ppm_data_first
| pointer remaining on the first byte of the first header if ppm is used
OPJ_UINT32 | ppm_data_size
| Number of bytes actually stored inside the ppm_data.
OPJ_INT32 | ppm_store
| use in case of multiple marker PPM (number of info already store)
OPJ_INT32 | ppm_previous
| use in case of multiple marker PPM (case on non-finished previous info)
opj_tcp_t * | tcps
| tile coding parameters
union { |
opj_decoding_param_t m_dec |
opj_encoding_param_t m_enc |
} | m_specific_param
OPJ_BOOL | strict
| OPJ_TRUE if entire bit stream must be decoded, OPJ_FALSE if partial bitstream decoding allowed.
OPJ_BOOL | epc_on
| enables writing of EPC in MH, thus activating JPWL
OPJ_BOOL | epb_on
| enables writing of EPB, in case of activated JPWL
OPJ_BOOL | esd_on
| enables writing of ESD, in case of activated JPWL
OPJ_BOOL | info_on
| enables writing of informative techniques of ESD, in case of activated JPWL
OPJ_BOOL | red_on
| enables writing of RED, in case of activated JPWL
int | hprot_MH
| error protection method for MH (0,1,16,32,37-128)
int | hprot_TPH_tileno [JPWL_MAX_NO_TILESPECS]
| tile number of header protection specification (>=0)
int | hprot_TPH [JPWL_MAX_NO_TILESPECS]
| error protection methods for TPHs (0,1,16,32,37-128)
int | pprot_tileno [JPWL_MAX_NO_PACKSPECS]
| tile number of packet protection specification (>=0)
int | pprot_packno [JPWL_MAX_NO_PACKSPECS]
| packet number of packet protection specification (>=0)
int | pprot [JPWL_MAX_NO_PACKSPECS]
| error protection methods for packets (0,1,16,32,37-128)
int | sens_size
| enables writing of ESD, (0/2/4 bytes)
int | sens_addr
| sensitivity addressing size (0=auto/2/4 bytes)
int | sens_range
| sensitivity range (0-3)
int | sens_MH
| sensitivity method for MH (-1,0-7)
int | sens_TPH_tileno [JPWL_MAX_NO_TILESPECS]
| tile number of sensitivity specification (>=0)
int | sens_TPH [JPWL_MAX_NO_TILESPECS]
| sensitivity methods for TPHs (-1,0-7)
OPJ_BOOL | correct
| enables JPWL correction at the decoder
int | exp_comps
| expected number of components at the decoder
OPJ_UINT32 | max_tiles
| maximum number of tiles at the decoder
OPJ_BITFIELD | ppm: 1
| if ppm == 1 --> there was a PPM marker
OPJ_BITFIELD | m_is_decoder: 1
| tells if the parameter is a coding or decoding one
OPJ_BITFIELD | allow_different_bit_depth_sign: 1
| whether different bit depth or sign per component is allowed.

## Detailed Description

Coding parameters.

## Field Documentation

## ◆ allow_different_bit_depth_sign

OPJ_BITFIELD opj_cp::allow_different_bit_depth_sign

whether different bit depth or sign per component is allowed.

Decoder only for ow

Referenced by opj_j2k_create_decompress(), opj_j2k_read_siz(), and opj_jp2_read_ihdr().

## ◆ comment

OPJ_CHAR* opj_cp::comment

comment

Referenced by opj_j2k_cp_destroy(), opj_j2k_setup_encoder(), opj_j2k_setup_header_writing(), and opj_j2k_write_com().

## ◆ correct

OPJ_BOOL opj_cp::correct

enables JPWL correction at the decoder

Referenced by opj_j2k_read_qcc(), opj_j2k_read_rgn(), opj_j2k_read_siz(), opj_j2k_read_sot(), opj_j2k_read_SQcd_SQcc(), and opj_j2k_setup_decoder().

## ◆ epb_on

OPJ_BOOL opj_cp::epb_on

enables writing of EPB, in case of activated JPWL

Referenced by opj_j2k_setup_encoder().

## ◆ epc_on

OPJ_BOOL opj_cp::epc_on

enables writing of EPC in MH, thus activating JPWL

Referenced by opj_j2k_setup_encoder().

## ◆ esd_on

OPJ_BOOL opj_cp::esd_on

enables writing of ESD, in case of activated JPWL

Referenced by opj_j2k_setup_encoder().

## ◆ exp_comps

int opj_cp::exp_comps

expected number of components at the decoder

Referenced by opj_j2k_read_siz(), and opj_j2k_setup_decoder().

## ◆ hprot_MH

int opj_cp::hprot_MH

error protection method for MH (0,1,16,32,37-128)

Referenced by opj_j2k_setup_encoder().

## ◆ hprot_TPH

int opj_cp::hprot_TPH[JPWL_MAX_NO_TILESPECS]

error protection methods for TPHs (0,1,16,32,37-128)

Referenced by opj_j2k_setup_encoder().

## ◆ hprot_TPH_tileno

int opj_cp::hprot_TPH_tileno[JPWL_MAX_NO_TILESPECS]

tile number of header protection specification (>=0)

Referenced by opj_j2k_setup_encoder().

## ◆ info_on

OPJ_BOOL opj_cp::info_on

enables writing of informative techniques of ESD, in case of activated JPWL

Referenced by opj_j2k_setup_encoder().

## ◆ m_dec

opj_decoding_param_t opj_cp::m_dec

Referenced by opj_j2k_decode(), opj_j2k_read_cod(), opj_j2k_read_siz(), opj_j2k_read_SPCod_SPCoc(), opj_j2k_set_decode_area(), opj_j2k_set_decoded_resolution_factor(), opj_j2k_setup_decoder(), and opj_tcd_init_tile().

## ◆ m_enc

opj_encoding_param_t opj_cp::m_enc

Referenced by opj_j2k_cp_destroy(), opj_j2k_get_num_tp(), opj_j2k_setup_encoder(), opj_j2k_update_rates(), opj_pi_create_encode(), opj_pi_initialise_encode(), opj_t2_decode_packets(), opj_t2_encode_packets(), opj_tcd_init(), opj_tcd_makelayer_fixed(), opj_tcd_rate_allocate_encode(), and opj_tcd_rateallocate().

## ◆ m_is_decoder

OPJ_BITFIELD opj_cp::m_is_decoder

tells if the parameter is a coding or decoding one

Referenced by opj_j2k_cp_destroy(), opj_j2k_create_compress(), and opj_j2k_create_decompress().

## ◆ [union]

union { ... } opj_cp::m_specific_param

Referenced by opj_j2k_cp_destroy(), opj_j2k_decode(), opj_j2k_get_num_tp(), opj_j2k_read_cod(), opj_j2k_read_siz(), opj_j2k_read_SPCod_SPCoc(), opj_j2k_set_decode_area(), opj_j2k_set_decoded_resolution_factor(), opj_j2k_setup_decoder(), opj_j2k_setup_encoder(), opj_j2k_update_rates(), opj_pi_create_encode(), opj_pi_initialise_encode(), opj_t2_decode_packets(), opj_t2_encode_packets(), opj_tcd_init(), opj_tcd_init_tile(), opj_tcd_makelayer_fixed(), opj_tcd_rate_allocate_encode(), and opj_tcd_rateallocate().

## ◆ max_tiles

OPJ_UINT32 opj_cp::max_tiles

maximum number of tiles at the decoder

Referenced by opj_j2k_read_siz(), and opj_j2k_setup_decoder().

## ◆ ppm

OPJ_BITFIELD opj_cp::ppm

if ppm == 1 --> there was a PPM marker

Referenced by opj_j2k_merge_ppm(), opj_j2k_read_ppm(), opj_j2k_read_ppt(), and opj_t2_read_packet_header().

## ◆ ppm_buffer

OPJ_BYTE* opj_cp::ppm_buffer

packet header storage original buffer

Referenced by opj_j2k_cp_destroy(), and opj_j2k_merge_ppm().

## ◆ ppm_data

OPJ_BYTE* opj_cp::ppm_data

packet header store there for future use in t2_decode_packet

Referenced by opj_j2k_cp_destroy(), opj_j2k_merge_ppm(), and opj_t2_read_packet_header().

## ◆ ppm_data_current

OPJ_BYTE* opj_cp::ppm_data_current

## ◆ ppm_data_first

OPJ_BYTE* opj_cp::ppm_data_first

pointer remaining on the first byte of the first header if ppm is used

## ◆ ppm_data_read

OPJ_UINT32 opj_cp::ppm_data_read

size of the ppm_data

## ◆ ppm_data_size

OPJ_UINT32 opj_cp::ppm_data_size

Number of bytes actually stored inside the ppm_data.

Referenced by opj_j2k_merge_ppm().

## ◆ ppm_len

OPJ_UINT32 opj_cp::ppm_len

size of the ppm_data

Referenced by opj_j2k_merge_ppm(), and opj_t2_read_packet_header().

## ◆ ppm_markers

opj_ppx* opj_cp::ppm_markers

ppm markers data (table indexed by Zppm)

Referenced by opj_j2k_cp_destroy(), opj_j2k_merge_ppm(), and opj_j2k_read_ppm().

## ◆ ppm_markers_count

OPJ_UINT32 opj_cp::ppm_markers_count

number of ppm markers (reserved size)

Referenced by opj_j2k_cp_destroy(), opj_j2k_merge_ppm(), and opj_j2k_read_ppm().

## ◆ ppm_previous

OPJ_INT32 opj_cp::ppm_previous

use in case of multiple marker PPM (case on non-finished previous info)

## ◆ ppm_store

OPJ_INT32 opj_cp::ppm_store

use in case of multiple marker PPM (number of info already store)

## ◆ pprot

int opj_cp::pprot[JPWL_MAX_NO_PACKSPECS]

error protection methods for packets (0,1,16,32,37-128)

Referenced by opj_j2k_setup_encoder().

## ◆ pprot_packno

int opj_cp::pprot_packno[JPWL_MAX_NO_PACKSPECS]

packet number of packet protection specification (>=0)

Referenced by opj_j2k_setup_encoder().

## ◆ pprot_tileno

int opj_cp::pprot_tileno[JPWL_MAX_NO_PACKSPECS]

tile number of packet protection specification (>=0)

Referenced by opj_j2k_setup_encoder().

## ◆ red_on

OPJ_BOOL opj_cp::red_on

enables writing of RED, in case of activated JPWL

Referenced by opj_j2k_setup_encoder().

## ◆ rsiz

OPJ_UINT16 opj_cp::rsiz

Size of the image in bits.

Rsiz

Referenced by opj_j2k_get_specific_header_sizes(), opj_j2k_mct_validation(), opj_j2k_read_siz(), opj_j2k_setup_encoder(), opj_j2k_setup_header_writing(), opj_j2k_write_first_tile_part(), opj_j2k_write_siz(), opj_pi_create_encode(), opj_pi_initialise_encode(), opj_t2_encode_packets(), and opj_tcd_rateallocate().

## ◆ sens_addr

int opj_cp::sens_addr

sensitivity addressing size (0=auto/2/4 bytes)

Referenced by opj_j2k_setup_encoder().

## ◆ sens_MH

int opj_cp::sens_MH

sensitivity method for MH (-1,0-7)

Referenced by opj_j2k_setup_encoder().

## ◆ sens_range

int opj_cp::sens_range

sensitivity range (0-3)

Referenced by opj_j2k_setup_encoder().

## ◆ sens_size

int opj_cp::sens_size

enables writing of ESD, (0/2/4 bytes)

Referenced by opj_j2k_setup_encoder().

## ◆ sens_TPH

int opj_cp::sens_TPH[JPWL_MAX_NO_TILESPECS]

sensitivity methods for TPHs (-1,0-7)

Referenced by opj_j2k_setup_encoder().

## ◆ sens_TPH_tileno

int opj_cp::sens_TPH_tileno[JPWL_MAX_NO_TILESPECS]

tile number of sensitivity specification (>=0)

Referenced by opj_j2k_setup_encoder().

## ◆ strict

OPJ_BOOL opj_cp::strict

OPJ_TRUE if entire bit stream must be decoded, OPJ_FALSE if partial bitstream decoding allowed.

Referenced by opj_j2k_create_decompress(), opj_j2k_decode_tile(), opj_j2k_decoder_set_strict_mode(), opj_j2k_read_sod(), opj_t2_read_packet_data(), and opj_t2_skip_packet_data().

## ◆ tcps

opj_tcp_t* opj_cp::tcps

tile coding parameters

Referenced by j2k_dump(), opj_get_all_encoding_parameters(), opj_get_encoding_packet_count(), opj_get_encoding_parameters(), opj_j2k_calculate_tp(), opj_j2k_compare_coc(), opj_j2k_compare_SPCod_SPCoc(), opj_j2k_compare_SQcd_SQcc(), opj_j2k_copy_default_tcp_and_create_tcd(), opj_j2k_copy_tile_component_parameters(), opj_j2k_copy_tile_quantization_parameters(), opj_j2k_cp_destroy(), opj_j2k_decode_one_tile(), opj_j2k_decode_tile(), opj_j2k_decode_tiles(), opj_j2k_encoder_set_extra_options(), opj_j2k_encoding_validation(), opj_j2k_get_max_poc_size(), opj_j2k_get_max_toc_size(), opj_j2k_get_num_tp(), opj_j2k_get_SPCod_SPCoc_size(), opj_j2k_get_SQcd_SQcc_size(), opj_j2k_mct_validation(), opj_j2k_pre_write_tile(), opj_j2k_read_coc(), opj_j2k_read_cod(), opj_j2k_read_mcc(), opj_j2k_read_mco(), opj_j2k_read_mct(), opj_j2k_read_poc(), opj_j2k_read_ppt(), opj_j2k_read_rgn(), opj_j2k_read_siz(), opj_j2k_read_sod(), opj_j2k_read_sot(), opj_j2k_read_SPCod_SPCoc(), opj_j2k_read_SQcd_SQcc(), opj_j2k_read_tile_header(), opj_j2k_set_decode_area(), opj_j2k_setup_encoder(), opj_j2k_update_rates(), opj_j2k_write_all_tile_parts(), opj_j2k_write_coc_in_memory(), opj_j2k_write_cod(), opj_j2k_write_first_tile_part(), opj_j2k_write_mco(), opj_j2k_write_mct_data_group(), opj_j2k_write_poc(), opj_j2k_write_poc_in_memory(), opj_j2k_write_regions(), opj_j2k_write_rgn(), opj_j2k_write_sot(), opj_j2k_write_SPCod_SPCoc(), opj_j2k_write_SQcd_SQcc(), opj_pi_check_next_level(), opj_pi_create(), opj_pi_create_decode(), opj_pi_create_encode(), opj_pi_initialise_encode(), opj_pi_update_encode_not_poc(), opj_pi_update_encode_poc_and_final(), opj_pi_update_encoding_parameters(), opj_t2_decode_packets(), opj_t2_encode_packets(), opj_tcd_decode_tile(), opj_tcd_encode_tile(), and opj_tcd_init_tile().

## ◆ tdx

OPJ_UINT32 opj_cp::tdx

XTsiz.

Referenced by j2k_get_cstr_info(), opj_get_all_encoding_parameters(), opj_get_encoding_parameters(), opj_image_comp_header_update(), opj_j2k_decode_tiles(), opj_j2k_dump_MH_info(), opj_j2k_encoding_validation(), opj_j2k_get_tile(), opj_j2k_read_siz(), opj_j2k_set_decode_area(), opj_j2k_setup_encoder(), opj_j2k_update_rates(), opj_j2k_write_siz(), and opj_tcd_init_tile().

## ◆ tdy

OPJ_UINT32 opj_cp::tdy

YTsiz.

Referenced by j2k_get_cstr_info(), opj_get_all_encoding_parameters(), opj_get_encoding_parameters(), opj_image_comp_header_update(), opj_j2k_decode_tiles(), opj_j2k_dump_MH_info(), opj_j2k_encoding_validation(), opj_j2k_get_tile(), opj_j2k_read_siz(), opj_j2k_set_decode_area(), opj_j2k_setup_encoder(), opj_j2k_update_rates(), opj_j2k_write_siz(), and opj_tcd_init_tile().

## ◆ th

OPJ_UINT32 opj_cp::th

number of tiles in height

Referenced by j2k_dump(), j2k_get_cstr_info(), opj_get_all_encoding_parameters(), opj_get_encoding_packet_count(), opj_get_encoding_parameters(), opj_image_comp_header_update(), opj_j2k_allocate_tile_element_cstr_index(), opj_j2k_calculate_tp(), opj_j2k_copy_default_tcp_and_create_tcd(), opj_j2k_cp_destroy(), opj_j2k_decode_one_tile(), opj_j2k_decode_tiles(), opj_j2k_dump_MH_info(), opj_j2k_encode(), opj_j2k_encoder_set_extra_options(), opj_j2k_get_max_coc_size(), opj_j2k_get_max_poc_size(), opj_j2k_get_max_toc_size(), opj_j2k_get_num_tp(), opj_j2k_get_SPCod_SPCoc_size(), opj_j2k_get_specific_header_sizes(), opj_j2k_get_SQcd_SQcc_size(), opj_j2k_get_tile(), opj_j2k_mct_validation(), opj_j2k_pre_write_tile(), opj_j2k_read_siz(), opj_j2k_read_sot(), opj_j2k_read_tile_header(), opj_j2k_read_tlm(), opj_j2k_set_decode_area(), opj_j2k_setup_encoder(), opj_j2k_update_rates(), opj_j2k_write_SPCod_SPCoc(), opj_j2k_write_SQcd_SQcc(), opj_pi_create(), opj_pi_create_decode(), opj_pi_initialise_encode(), opj_pi_update_encode_not_poc(), opj_pi_update_encode_poc_and_final(), and opj_pi_update_encoding_parameters().

## ◆ tw

OPJ_UINT32 opj_cp::tw

number of tiles in width

Referenced by j2k_dump(), j2k_get_cstr_info(), opj_get_all_encoding_parameters(), opj_get_encoding_parameters(), opj_image_comp_header_update(), opj_j2k_allocate_tile_element_cstr_index(), opj_j2k_calculate_tp(), opj_j2k_copy_default_tcp_and_create_tcd(), opj_j2k_cp_destroy(), opj_j2k_decode_one_tile(), opj_j2k_decode_tiles(), opj_j2k_dump_MH_info(), opj_j2k_encode(), opj_j2k_encoder_set_extra_options(), opj_j2k_get_max_coc_size(), opj_j2k_get_max_poc_size(), opj_j2k_get_max_toc_size(), opj_j2k_get_num_tp(), opj_j2k_get_SPCod_SPCoc_size(), opj_j2k_get_specific_header_sizes(), opj_j2k_get_tile(), opj_j2k_mct_validation(), opj_j2k_pre_write_tile(), opj_j2k_read_siz(), opj_j2k_read_sot(), opj_j2k_read_tile_header(), opj_j2k_read_tlm(), opj_j2k_set_decode_area(), opj_j2k_setup_encoder(), opj_j2k_update_rates(), opj_j2k_write_SPCod_SPCoc(), and opj_tcd_init_tile().

## ◆ tx0

OPJ_UINT32 opj_cp::tx0

XTOsiz.

Referenced by j2k_get_cstr_info(), opj_get_all_encoding_parameters(), opj_get_encoding_parameters(), opj_image_comp_header_update(), opj_j2k_decode_tiles(), opj_j2k_dump_MH_info(), opj_j2k_get_tile(), opj_j2k_read_siz(), opj_j2k_set_decode_area(), opj_j2k_setup_encoder(), opj_j2k_update_rates(), opj_j2k_write_siz(), and opj_tcd_init_tile().

## ◆ ty0

OPJ_UINT32 opj_cp::ty0

YTOsiz.

Referenced by j2k_get_cstr_info(), opj_get_all_encoding_parameters(), opj_get_encoding_parameters(), opj_image_comp_header_update(), opj_j2k_decode_tiles(), opj_j2k_dump_MH_info(), opj_j2k_get_tile(), opj_j2k_read_siz(), opj_j2k_set_decode_area(), opj_j2k_setup_encoder(), opj_j2k_update_rates(), opj_j2k_write_siz(), and opj_tcd_init_tile().

The documentation for this struct was generated from the following file:

- j2k.h